<template>
  <q-card :square="!isDesktopPlatform">
    <q-card-section v-if="loading">
      <div
        class="row flex-center"
      >
        <q-spinner-dots
          color="primary"
          size="40px"
        />
      </div>
    </q-card-section>

    <template v-else-if="customFertilizers">
      <q-list
        v-if="customFertilizers.length > 0"
        separator
      >
        <q-item
          v-for="customFertilizer in customFertilizers"
          :key="customFertilizer.id"
          :clickable="canCreateAndEditCustomFertilizer"
          v-ripple
          @click="onEditCustomFertilizer(customFertilizer)"
        >
          <q-item-section
            side
          >
            <q-icon
              name="las la-flask"
            />
          </q-item-section>

          <q-item-section class="text-body2">
            <q-item-label lines="1">
              {{ customFertilizer.name }}
            </q-item-label>
            <q-item-label
              lines="1"
              caption
            >
              {{ displayChemicalElements(customFertilizer) }}
            </q-item-label>
            <q-item-label
              lines="1"
              caption
            >
              {{ displayOrganic(customFertilizer) }}
            </q-item-label>
          </q-item-section>

          <q-item-section
            v-if="canCreateAndEditCustomFertilizer"
            side
            top
          >
            <q-icon
              name="las la-angle-right"
              class="q-mt-auto q-mb-auto"
            />
          </q-item-section>
        </q-item>
      </q-list>

      <q-card-section
        v-else
        class="text-body2 text-grey"
      >
        <translate>No fertilizers</translate>
      </q-card-section>
    </template>

    <q-card-actions
      align="right"
      v-if="canCreateAndEditCustomFertilizer"
    >
      <q-btn
        outline
        color="primary"
        @click="onNewCustomFertilizer"
        class="q-mr-sm q-mb-sm"
      >
        <translate>
          New fertilizer
        </translate>
      </q-btn>
    </q-card-actions>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import queryCustomFertilizers from 'src/pages/holding-campaign/custom-fertilizer/graphql/queryCustomFertilizers'
import featureFlags from 'src/services/feature-flags'

export default {
  name: 'CustomFertilizersCard',
  mixins: [
    PlatformMixin
  ],
  apollo: {
    customFertilizers: {
      query: queryCustomFertilizers,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          holdingId: this.holdingId
        }
      }
    }
  },
  computed: {
    loading () {
      return !this.customFertilizers && !this.$apollo.queries.customFertilizers.loading
    },
    canCreateAndEditCustomFertilizer () {
      return featureFlags.canCreateAndEditCustomFertilizer()
    },
    holdingId () {
      return this.$store.state.fastplatform.holdingCampaign.holding.id
    }
  },
  methods: {
    displayChemicalElements (customFertilizer) {
      if (customFertilizer.customFertilizerElements) {
        return customFertilizer.customFertilizerElements.map(({ chemicalElement, percentage }) => `${chemicalElement.id} (${percentage}%)`).join(', ')
      }
      return ''
    },
    displayOrganic (customFertilizer) {
      return customFertilizer.organic ? this.$gettext('Organic') : this.$gettext('Non-organic')
    },
    onEditCustomFertilizer (customFertilizerId) {
      this.$router.push({ name: 'holdingCustomFertilizerEdit', params: { customFertilizerId: customFertilizerId.id } })
    },
    onNewCustomFertilizer () {
      this.$router.push({ name: 'holdingCustomFertilizerCreate' })
    }
  }
}

</script>
